package ir.metrix.flutter

import io.flutter.plugin.common.EventChannel
import ir.metrix.UserIdListener

class UserIdReader: EventChannel.StreamHandler {
    private var userIdEventSink: EventChannel.EventSink? = null

    override fun onListen(arguments: Any?, events: EventChannel.EventSink?) {
        userIdEventSink = events
        ir.metrix.Metrix.setUserIdListener(
            object : UserIdListener {
                override fun onUserIdReceived(userId: String) {
                    userIdEventSink?.success(userId)
                }
            })
    }

    override fun onCancel(arguments: Any?) {
        userIdEventSink = null
    }
}